! calcualting pressure based on scale by Wu et al (JGR 2008)
PROGRAM scale

  IMPLICIT NONE

  INTEGER, PARAMETER :: DP = selected_real_kind(14,200)

  real(DP):: Cv(5),Ck(5),Cp(5),Ca(5)

  real(DP):: T,V,a0,P
  integer:: i
  integer:: num ! numbers of the point need to be calculated
! coefficient for calculating V_0
  Cv(1)=43.5682
  Cv(2)=0.00093312
  Cv(3)=1.55396E-05
  Cv(4)=-2.00042E-08
  Cv(5)=1.11544E-11

! coefficient for calculating K_0
  Ck(1)=28.2849
  Ck(2)=-0.00789309
  Ck(3)=-3.2731E-05
  Ck(4)=5.16117E-08
  Ck(5)=-2.83275E-11

! coefficient for calculating 
! K_prime(pressure derivative of bulk modulus)
  Cp(1)=4.56563
  Cp(2)=0.000602165
  Cp(3)=4.08104E-07
  Cp(4)=-5.2923e-10
  Cp(5)=5.36738E-13

!  Cp(1)=5.16303     
!  Cp(2)=-0.01535    
!  Cp(3)=8.46068e-05 
!  Cp(4)=-1.44476e-07
!  Cp(5)=7.50546e-11 

! coefficient for calculating A
!  Ca(1)=-0.1526
!  Ca(2)=-0.0769
!  Ca(3)=-0.0022
!  Ca(4)=0.00248
!  Ca(5)=-0.0006542
 

 open(unit=1,file="inputVT.txt")
 open(unit=10,file="outputPVT.txt")
 read(1,*)num
 write(10,*)"#Pressure based on MgO scale (Wu et al JGR 2008)"
 write(10,*)"Temperature(K)  lattice const.(A)    volume    pressure (GPa) "
 do i=1,num
  read(1,*)T,a0
    V=(a0**3.0)/4.0
!   V=a0
  call getpressure(V,T,P,Cv,Ck,Cp) 
  write(10,'(1f14.2,3f15.6)')T,a0,V,P
 enddo  

 end



SUBROUTINE getpressure(V,Temp,P,Cv,Ck,Cp)

 IMPLICIT NONE

 INTEGER, PARAMETER :: DP = selected_real_kind(14,200)

 real(DP):: Cv(5),Ck(5),Cp(5)

 real(DP):: V0,K0,Kp,V,T,P,term2,term3,Ra,Temp  

 integer:: i 

 T=Temp


  V0=0.0
  K0=0.0
  Kp=0.0

  do i=1,5
   V0=V0+Cv(i)*T**(i-1)   
   K0=K0+Ck(i)*T**(i-1)   
   Kp=Kp+Cp(i)*T**(i-1)   
  enddo
 ! write(10,*)V0,K0,Kp,A
   Ra=(V0/V)**(1.0/3.0)
   term2=0.75*(Kp-4.0)*(Ra**2.0-1.0)
 !  term3=A*(Ra**2.0-1.0)**2.0
   P=1.5*K0*(Ra**7.0-Ra**5.0)*(1.0+term2)
 !  write(10,*)Ra,term2,term3,P 

    Return
END SUBROUTINE getpressure
